/*	
 *	d12sys.h
 *
 *	PDIUSBD12 VXevO
 *	Copyright (c) 1997 Philips Semiconductors
 *	Copyright (c) 2002 Naoyuki Sawa
 *
 *	* Mon Aug 16 12:30:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __D12SYS_H__
#define __D12SYS_H__

typedef struct _DEVICE_REQUEST {
	unsigned char bmRequestType;
	unsigned char bRequest;
	unsigned short wValue;
	unsigned short wIndex;
	unsigned short wLength;
} DEVICE_REQUEST;

typedef struct _USBINFO {
	/* USBC mode */
	int mode; /* D12_ENDP_NONISO/ISOOUT/ISOIN/ISOIO */
	/* USBC raw event */
	void (*bus_reset)();
	void (*ep1_txdone)(int st);
	void (*ep1_rxdone)(int st);
	void (*ep2_txdone)(int st);
	void (*ep2_rxdone)(int st);
	/* Device request */
	void (*standard_request)(const DEVICE_REQUEST* req, const unsigned char* dat, int len);
	void (*class_request)(const DEVICE_REQUEST* req, const unsigned char* dat, int len);
	void (*vendor_request)(const DEVICE_REQUEST* req, const unsigned char* dat, int len);
} USBINFO;

void usb_hook(const USBINFO* ui);
void usb_unhook();
void usb_ep0_stall();
void usb_ep0_tx(const char* ptr, int len);

#endif /*__D12SYS_H__*/
